// P-III-4 Výlet
// Average-case time complexity: O(m^2)
// Worst-case time complexity: O(m^2*n)
#include <cassert>
#include <cstdio>
#include <unordered_set>

using namespace std;

struct Edge { int a, b; };

const int MAXN = 10000;

unordered_set<int> neighbors[MAXN];
Edge edges[MAXN * MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].insert(b);
    neighbors[b].insert(a);
    edges[i] = (Edge) { a, b };
    edges[m + i] = (Edge) { b, a };
  }
  for (int i = 0; i < m + m; i++) {
    int h1 = edges[i].a, h2 = edges[i].b;
    for (int j = 0; j < m + m; j++) {
      if (i == j) continue;
      int h3 = edges[j].a, h4 = edges[j].b;
      if (h3 == h1 || h3 == h2) continue;
      if (h4 == h1 || h4 == h2) continue;
      if (
        neighbors[h1].find(h4) != neighbors[h1].end()
        && neighbors[h2].find(h3) != neighbors[h2].end()
      ) {
        printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
        return 0;
      }
    }
  }
  printf("0\n");
  return 0;
}
