// P-III-4 Výlet
// Worst-case time complexity: O(n^3)
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 10000;

vector<int> neighbors[MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].push_back(b);
    neighbors[b].push_back(a);
  }
  for (int i = 0; i < n; i++) {
    sort(neighbors[i].begin(), neighbors[i].end());
  }
  for (int h1 = 0; h1 < n; h1++) {
    for (int h3 = 0; h3 < n; h3++) {
      if (h1 == h3) continue;
      int h2 = -1, h4 = -1;
      auto it1 = neighbors[h1].begin(), it2 = neighbors[h3].begin();
      while (it1 != neighbors[h1].end() && it2 != neighbors[h3].end()) {
        if (*it1 == *it2) {
          if (h2 == -1) {
            h2 = *it1;
          } else {
            h4 = *it1;
            printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
            return 0;
          }
          it1++;
          it2++;
        } else if (*it1 < *it2) {
          it1++;
        } else {
          it2++;
        }
      }
    }
  }
  printf("0\n");
  return 0;
}
