// P-III-4 Výlet
// Average-case time complexity: O(n^3)
// Worst-case time complexity: O(n^4)
#include <cassert>
#include <cstdio>
#include <unordered_set>
#include <vector>

using namespace std;

const int MAXN = 10000;

unordered_set<int> neighbors[MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].insert(b);
    neighbors[b].insert(a);
  }
  for (int h1 = 0; h1 < n; h1++) {
    for (int h3 = 0; h3 < n; h3++) {
      if (h1 == h3) continue;
      int h2 = -1, h4 = -1;
      for (int v = 0; v < n; v++) {
        if (v == h1 || v == h3) continue;
        if (
          neighbors[h1].find(v) != neighbors[h1].end() &&
          neighbors[h3].find(v) != neighbors[h3].end()
        ) {
          if (h2 == -1) {
            h2 = v;
          } else {
            h4 = v;
            printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
            return 0;
          }
        }
      }
    }
  }
  printf("0\n");
  return 0;
}
