// P-III-4 Výlet
// Worst-case time complexity: O(n^3*log(n))
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 10000;

vector<int> neighbors[MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].push_back(b);
    neighbors[b].push_back(a);
  }
  for (int i = 0; i < n; i++) {
    sort(neighbors[i].begin(), neighbors[i].end());
  }
  for (int h1 = 0; h1 < n; h1++) {
    for (int h3 = 0; h3 < n; h3++) {
      if (h1 == h3) continue;
      int h2 = -1, h4 = -1;
      for (int v = 0; v < n; v++) {
        if (v == h1 || v == h3) continue;
        auto it1 = lower_bound(neighbors[h1].begin(), neighbors[h1].end(), v);
        if (it1 == neighbors[h1].end() || *it1 != v) continue;
        auto it2 = lower_bound(neighbors[h3].begin(), neighbors[h3].end(), v);
        if (it2 == neighbors[h3].end() || *it2 != v) continue;
        if (h2 == -1) {
          h2 = v;
        } else {
          h4 = v;
          printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
          return 0;
        }
      }
    }
  }
  printf("0\n");
  return 0;
}
